/* Crista/SPAS TANS Recorder Packet viewer */
/* NOTE: This code assumes Intel byte ordering (LSB first) */
/*       The TANS recorder data is (as on packet description) MSB first */


#include "stdio.h"
#include "stdlib.h"
#include "strings.h"

unsigned short buf[200];

main(int argc, char *argv[])
{
	FILE *src, *dest;
	char srcfname[30], destfname[30];
	int header;
	unsigned short header2;

	if (argc == 1) {
		printf("\nEnter Source Filename: ");
		scanf("%s", srcfname);
		printf("\nEnter Destination Filename: ");
		scanf("%s", destfname);
		printf("\nEnter Packet Header to Extract (hex w/ 0x): ");
		scanf("%X", &header);
	}
	else if (argc == 4) {
		strcpy(srcfname, argv[1]);
		strcpy(destfname, argv[2]);
		sscanf(argv[3],"%X", &header);
	}
	else return;

	header2 = ((header << 8) | ((header >> 8) & 0x00ff));

	src = fopen(srcfname, "rb");
	if (src == NULL)	{ printf("\nError opening source file\n"); exit(1); }
	dest = fopen(destfname, "wb");
	if (dest == NULL)	{ printf("\nError opening destination file\n"); exit(1); }

	while (fread(&buf[0], sizeof(short), 32, src) == 32)
	{
		if (buf[0] == header2)
		{
			if (fwrite(&buf[0], 2, 32, dest) != 32)
			{
				printf("\nError writing to destination file..\n");
				fclose(src);
				fclose(dest);
				exit(1);
			}
		}
	}

	fclose(src);
	fclose(dest);
	printf("\nComplete...\n");
	return;
}
