
#include "stdio.h"
#include "stdlib.h"
#include "math.h"
#include <sys/types.h>

#define SCALE_FACTOR      4194304.0

unsigned short bufpc[200];
unsigned short buf[200];

void main(int argc, char *argv[])
{
	FILE *f;
        FILE *fquat;
	char fname[30];
	short i, stop = 0;
	float Q[4],bpfloat;
	double time;
        long  dw;
		
        if (argc == 1) {
                printf("\nEnter input filename: ");
                scanf("%s", fname);
        }
        else if (argc == 2) {
                strcpy(fname, argv[1]);
        }
        else return;

	f = fopen(fname, "rb");
	if (f == NULL)	{ printf("\nError opening file\n"); return; }

        fquat  = fopen("quatern.dat","w+");
	if (fquat == NULL)	{ printf("\nError opening file ""quatern.dat"" \n"); return; }

        printf("\n File %s...",fname);

        while (!stop)
	{
		do {
			if (fread(&bufpc[0], 2, 32, f) == 0) stop = 1;
			else {
				for (i = 0; i < 32; i++)
					buf[i] = ((bufpc[i] << 8) & 0xff00) | ((bufpc[i] >> 8) & 0xff);

				stop = 0;
			}

		} while ((buf[0] != 0x6ED) && (!stop)) ;

		if (stop) break;

                dw = (buf[7] << 16)  | buf[8];	    
                if (dw & 0x00800000) dw |= 0xFF000000; 
                bpfloat = dw;
                Q[0] = (bpfloat/SCALE_FACTOR);

                dw = (buf[9] << 16)  | buf[10];	    
                if (dw & 0x00800000) dw |= 0xFF000000; 
                bpfloat = dw;
                Q[1] = (bpfloat/SCALE_FACTOR);

                dw = (buf[11] << 16)  | buf[12];	    
                if (dw & 0x00800000) dw |= 0xFF000000; 
                bpfloat = dw;
                Q[2] = (bpfloat/SCALE_FACTOR);

                Q[3] = sqrt(fabs(1.0 - Q[0]*Q[0] - Q[1]*Q[1] - Q[2]*Q[2]));

		time = (buf[4] * 3600.0) + (buf[5] * 60.0) + (buf[6] * 1.0);

		fprintf(fquat," %12.8f %12.8f %12.8f %12.8f %12.3f \n", Q[0], Q[1], Q[2], Q[3],time);
	}	

        fclose(fquat);
	fclose(f);
        printf("Complete.\n\n");
        return;
}

